/*
   itoa.S

   Copyright (C) 2000 Michael Rickmann <mrickma@gwdg.de>

   Permission to use, copy, modify, and distribute this software and
   its documentation for any purpose and without fee is hereby granted,
   without any conditions or restrictions.  This software is provided
   "as is" without express or implied warranty.

	#include <stdlib.h>
	char *itoa(int value, char *string, int radix);
  ----------------------------------------------------------------------
*/

#include "macros.inc"
#include "ctoasm.inc"

	.global _U(itoa)
	.func _U(itoa)

_U(itoa):
	push	r16
	push	r17
	push	r28
	push	r29
	mov	r28, rP3	; *string
	mov	r29, rP2
	mov	rP3, rP5	; radix
	clr	rP2
	clr	rSI1		; count, clear for later
	clr	rSI0		; minus flag

	cpi	rP3, 2		; no radix < 2
	brlt	terminate
	cpi	rP3, 10		; decimal number ?
	brne	divide_loop
	and	rP0, rP0	; sign of value ?
	brge	divide_loop
	com	rP0		; make positive
	neg	rP1
	sbci	rP0,0xff
	ldi	rSI0, '-'	; store sign
divide_loop:
	FARCALL	_U(_udivhi3)	; quotient in rP1:rP0, remainder in r26:r27
	subi	r26, 0xd0	; + '0'
	cpi	r26, 0x3a	; > '9' ?
	brlt	L_10
	subi	r26, 0xd9	; + 'a' - 10 - '0'
L_10:
	push	r26		; save char on stack
	inc	rSI1		; increment char count
	sbiw	rP1, 0		; value == 0 ?
	brne	divide_loop

	mov	rP1, r28	; return start of *string
	mov	rP0, r29
	tst	rSI0		; minus sign ?
	brne	store_char
	rjmp	test_count
character_loop:
	pop	rSI0		; restore character
	dec	rSI1		; decrement count
store_char:
	st	Y+, rSI0	; store character
test_count:
	tst	rSI1		; count == 0 ?
	brne	character_loop
terminate:
	st	Y, rSI1		; terminator

	pop	r29
	pop	r28
	pop	r17
	pop	r16
	ret

	.endfunc

